/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */
 

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();
}


/**
 * CharacterController
 * Keeps track of characters.
 */
function CharacterController () {
    this.character = null;
    this.characterIndex = 0;
    this.history = [];
}

CharacterController.prototype.selectNextCharacter = function() {
    var allChars = new Array();
    if (ccGetPreference("prefHSK1") == "yes") {
        if (ccGetPreference("prefSimplifiedTraditional") == "simplified") {
            allChars = allChars.concat(ccHSK1Simp);
        } else {
            allChars = allChars.concat(ccHSK1Trad);
        }
    }
    if (ccGetPreference("prefHSK2") == "yes") {
        if (ccGetPreference("prefSimplifiedTraditional") == "simplified") {
            allChars = allChars.concat(ccHSK2Simp);
        } else {
            allChars = allChars.concat(ccHSK2Trad);
        }
    }
    if (ccGetPreference("prefHSK3") == "yes") {
        if (ccGetPreference("prefSimplifiedTraditional") == "simplified") {
            allChars = allChars.concat(ccHSK3Simp);
        } else {
            allChars = allChars.concat(ccHSK3Trad);
        }
    }
    if (ccGetPreference("prefHSK4") == "yes") {
        if (ccGetPreference("prefSimplifiedTraditional") == "simplified") {
            allChars = allChars.concat(ccHSK4Simp);
        } else {
            allChars = allChars.concat(ccHSK4Trad);
        }
    }
    var i = Math.round(Math.random() * (allChars.length-1));
    this.history.push(allChars[i]);
    this.characterIndex = this.history.length - 1;
};

CharacterController.prototype.selectPreviousCharacter = function() {
    this.characterIndex--;
    if (this.characterIndex <= 0) {
        this.characterIndex = 0;
    }
};

CharacterController.prototype.getCharacter = function() {
    return this.history[this.characterIndex][0];
};

CharacterController.prototype.getPinyin = function() {
    return this.history[this.characterIndex][1];
};

CharacterController.prototype.getDefinition = function() {
    return this.history[this.characterIndex][2];
};

var gCCon = new CharacterController();



//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
    ccSetup();
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
    ccDisplayPreferences();
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
    ccStorePermissions();
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}


/******************************************************************
 * Screen Switching and Display
 ******************************************************************/


var ccCurrentScreen = "challenge"; // Can be: "challenge", "answer"

function ccDoNext() {
    gCCon.selectNextCharacter();
    ccBackToChallenge()
    ccDrawCharacter();
}

function ccDoBack() {
    gCCon.selectPreviousCharacter();
    ccBackToChallenge();
    ccDrawCharacter();

}

function ccToggleAnswer() {
    if (ccCurrentScreen == "challenge") {
        ccRevealAnswer();
    } else if (ccCurrentScreen == "answer") {
        ccBackToChallenge();
    }
}

function ccRevealAnswer() {
    var cP = document.getElementById("challengeAndPinyin");
    var topPosition = 30;
    var originalTop = parseInt(document.defaultView.getComputedStyle(cP, null).getPropertyValue("top"), 10);
    var moveHandler = function(a, c, s, f) {
        cP.style.top = c + "px";
        if (f) {
            ccShowPinyin();
            ccShowDefinition();
        }
    };
    var a = new AppleAnimator(125, 13, originalTop, topPosition, moveHandler);
    a.start();
    var b = document.getElementById("revealButton");
    b.object.textElement.innerText = "Back";
    ccCurrentScreen = "answer";
}

function ccBackToChallenge() {
    var cP = document.getElementById("challengeAndPinyin");
    var topPosition = 107;
    var originalTop = parseInt(document.defaultView.getComputedStyle(cP, null).getPropertyValue("top"), 10);
    var moveHandler = function(a, c, s, f) {
        cP.style.top = c + "px";
    };
    var a = new AppleAnimator(125, 13, originalTop, topPosition, moveHandler);
    a.start();
    ccHideDefinition();
    var b = document.getElementById("revealButton");
    b.object.textElement.innerText = "Reveal";
    ccCurrentScreen = "challenge";
    ccHidePinyin();
}

function ccSetup() {
    ccHideDefinition();
    ccHidePinyin();
    gCCon.selectNextCharacter();
    ccDrawCharacter();
}

function ccShowPinyin() {
    var pY = document.getElementById("pinyinText");
    pY.hidden = false;
}

function ccHidePinyin() {
    var pY = document.getElementById("pinyinText");
    if (ccCurrentScreen != "answer") {
        pY.hidden = true;
    }
}

function ccShowDefinition() {
    var dT = document.getElementById("definitionText");
    dT.hidden = false;    
}

function ccHideDefinition() {
    var dT = document.getElementById("definitionText");
    dT.hidden = true;    

}

function ccDrawCharacter() {
    var c = gCCon.getCharacter();
    var cT = document.getElementById("challengeText");
    cT.textContent = c;
    var pT = document.getElementById("pinyinText");
    pT.textContent = gCCon.getPinyin();
    var dT = document.getElementById("definitionText");
    dT.textContent = gCCon.getDefinition();
}

// Loads permissions, and provides default values if undefined.
function ccGetPreference(key) {
    switch (key) {
        case "prefSimplifiedTraditional":
            var val = widget.preferenceForKey(key);
            if (val == undefined) {
                val = "simplified";
            }
        break;
        case "prefHSK1":
            var val = widget.preferenceForKey(key);
            if (val == undefined) {
                val = "yes";
            }
        break;
        case "prefHSK2":
            var val = widget.preferenceForKey(key);
            if (val == undefined) {
                val = "no";
            }
        break;
        case "prefHSK3":
            var val = widget.preferenceForKey(key);
            if (val == undefined) {
                val = "no";
            }
        break;
        case "prefHSK4":
            var val = widget.preferenceForKey(key);
            if (val == undefined) {
                val = "no";
            }
        break;

    }
    return val;
}

function ccDisplayPreferences() {
    var simplifiedOrTraditional = ccGetPreference("prefSimplifiedTraditional");
    if (simplifiedOrTraditional == "simplified") {
        var r = document.getElementById("radioSimplified");
        r.childNodes[1].checked = true;
    } else if (simplifiedOrTraditional == "traditional") {
        var r = document.getElementById("radioTraditional");
        r.childNodes[1].checked = true;
    }

    var hsk1 = ccGetPreference("prefHSK1");
    if (hsk1 == "yes") {
        r = document.getElementById("checkHSK1");
        r.childNodes[1].checked = true;
    } else {
        r = document.getElementById("checkHSK1");
        r.childNodes[1].checked = false;
    }

    var hsk2 = ccGetPreference("prefHSK2");
    if (hsk2 == "yes") {
        r = document.getElementById("checkHSK2");
        r.childNodes[1].checked = true;
    } else {
        r = document.getElementById("checkHSK2");
        r.childNodes[1].checked = false;
    }
    
    var hsk3 = ccGetPreference("prefHSK3");
    if (hsk3 == "yes") {
        r = document.getElementById("checkHSK3");
        r.childNodes[1].checked = true;
    } else {
        r = document.getElementById("checkHSK3");
        r.childNodes[1].checked = false;
    }
    
    var hsk4 = ccGetPreference("prefHSK4");
    if (hsk4 == "yes") {
        r = document.getElementById("checkHSK4");
        r.childNodes[1].checked = true;
    } else {
        r = document.getElementById("checkHSK4");
        r.childNodes[1].checked = false;
    }

}

function ccStorePermissions() {
    var r = document.getElementById("radioSimplified");
    if (r.childNodes[1].checked) {
        widget.setPreferenceForKey("simplified", "prefSimplifiedTraditional");
    } else {
        widget.setPreferenceForKey("traditional", "prefSimplifiedTraditional");
    }
    
    r = document.getElementById("checkHSK1");
    if (r.childNodes[1].checked) {
        widget.setPreferenceForKey("yes", "prefHSK1");
    } else {
        widget.setPreferenceForKey("no", "prefHSK1");
    }

    r = document.getElementById("checkHSK2");
    if (r.childNodes[1].checked) {
        widget.setPreferenceForKey("yes", "prefHSK2");
    } else {
        widget.setPreferenceForKey("no", "prefHSK2");
    }

    r = document.getElementById("checkHSK3");
    if (r.childNodes[1].checked) {
        widget.setPreferenceForKey("yes", "prefHSK3");
    } else {
        widget.setPreferenceForKey("no", "prefHSK3");
    }

    r = document.getElementById("checkHSK4");
    if (r.childNodes[1].checked) {
        widget.setPreferenceForKey("yes", "prefHSK4");
    } else {
        widget.setPreferenceForKey("no", "prefHSK4");
    }
}

function ccGoWebsite() {
   widget.openURL("http://www.antunkarlovac.com"); 

}